// Copyright (c) 2015, Will Squire. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

library functional_behaviour_tree.composite;

import 'node.dart';
import 'dart:async';

/// Composite nodes (also know as the control flow nodes, or a branch) are nodes that contain an array of nodes within
/// themselves, along with the logic behind how these encapsulated nodes should be executed. As such,
/// these nodes are responsible for controlling the flow of execution of the encapsulated nodes within them through use of their own logic.

/// The two most common types of composite nodes are the Selector and Sequence nodes.
/// Both of these are included in this framework.
typedef Future<bool> Composite(Map blackboard, List<Node> nodes);