// Copyright (c) 2015, Will Squire. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

library functional_behaviour_tree.test.node;

import 'package:test/test.dart';
import 'package:functional_behaviour_tree/functional_behaviour_tree.dart';
import 'dart:async';
import 'nodes/isHttpStatus.dart';

node_test() {
  group('Node with declaration', () {

    Node node;

    setUp(() {
      // Assign function declaration
      node = isHttpStatusCode404;
    });

    test('Can return true', () {
      return node({'http_status_code' : '404'}).then((bool value) { expect(value, isTrue); });
    });

    test('Can return false', () {
      return node({'http_status_code' : '401'}).then((bool value) { expect(value, isFalse); });
    });

  });

  group('Node with expression', () {

    Node node;

    setUp(() {
      // Assign function expression
      node = (blackboard) {
        if (blackboard['http_status_code'] == '404')
          return new Future(() => true);
        return new Future(() => false);
      };
    });

    test('Can return true', () {
      return node({'http_status_code' : '404'}).then((bool value) { expect(value, isTrue); });
    });

    test('Can return false', () {
      return node({'http_status_code' : '401'}).then((bool value) { expect(value, isFalse); });
    });

  });
}
