// Copyright (c) 2015, Will Squire. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

library functional_behaviour_tree.test.sequence;

import 'package:test/test.dart';
import 'package:functional_behaviour_tree/functional_behaviour_tree.dart';
import 'nodes/isHttpStatus.dart';
import 'nodes/user.dart';

sequence_test() {
  group('Sequence', () {

    test('Can return true', () {
      return isHttpStatusCode({
          'http_status_code' : '400',
          'user_id' : '01'
      }).then((bool value) { expect(value, isTrue); });
    });

    test('Can return false', () {
      return isHttpStatusCode({'http_status_code' : '401'}).then((bool value) { expect(value, isFalse); });
    });

  });
}

isHttpStatusCode(Map blackboard) => sequence(blackboard, [
    isHttpStatusCode400,
    isUserIdSet,
]);